trigger_job:
  stage: .post
  trigger:
    include: child-pipeline.yml

stages:
  - deploy
  - build
  - uat

.tag_template: &template
  tags:
    - CI
    - Devops

default:
  timeout: 1 hours 30 minutes

pre-job:
  stage: .pre
  <<: *template
  before_script:
    - sudo docker login registry.gitlab.com -u vuthanhtb.dev -p $access_token
  script:
    - echo "First Job"
    - echo "Pipeline url $CI_PIPELINE_URL"
    - echo "Pipeline id $CI_PIPELINE_IID"
    - echo "Project name $CI_PROJECT_NAME"
    - echo "Author $author"
    - sudo docker build -t registry.gitlab.com/vuthanhtb.dev/gitlab-yaml-pipeline:$CI_PIPELINE_IID .
    - sudo docker push registry.gitlab.com/vuthanhtb.dev/gitlab-yaml-pipeline:$CI_PIPELINE_IID

post-job:
  stage: .post
  <<: *template
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
  script:
    - echo "latest Job"

build-job:
  stage: build
  <<: *template
  needs: []
  variables:
    env: develop
  before_script:
    - echo "Test before script"
  after_script:
    - echo "Test after script"
  script:
    - echo "Build Application $env"
    - sudo docker images

deploy-job:
  stage: deploy
  <<: *template
  only:
    - main
  when: on_success
  allow_failure: true
  retry: 2
  parallel: 5
  inherit:
    default: false
  environment:
    name: prod
    url: http://103.109.37.225:8080
  script:
    - echo "Run Deploy"
    - sudo docker images
    - sudo docker rm -f $(sudo docker ps -a -q)
    - sudo docker inspect registry.gitlab.com/vuthanhtb.dev/gitlab-yaml-pipeline:$CI_PIPELINE_IID
    - sudo docker run -itd -p 8080:80 registry.gitlab.com/vuthanhtb.dev/gitlab-yaml-pipeline:$CI_PIPELINE_IID

uat-job:
  stage: uat
  <<: *template
  needs:
    - deploy-job
  except:
    - master
  artifacts:
    name: devops
    when: on_failure
    paths:
      - $CI_PROJECT_DIR/
    exclude:
      - Dockerfile
    expire_in: 1 week
  cache:
    key: my_cache
    paths:
      - ./
  environment:
    name: staging
  script:
    - echo "Run UAT"
    - sudo docker run -itd -p 80:80 registry.gitlab.com/vuthanhtb.dev/gitlab-yaml-pipeline:$CI_PIPELINE_IID
